io.vertx.ext.consul

## Interface ConsulClient

-     public interface ConsulClient

  A Vert.x service used to interact with Consul.
  Author:
    Ruslan Sennov

- - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `Future<JsonObject>` | `agentInfo()` Like `agentInfo(Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `agentInfo(Handler<AsyncResult<JsonObject>> resultHandler)` Returns the configuration and member information of the local agent
    `Future<List<String>>` | `catalogDatacenters()` Like `catalogDatacenters(Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `catalogDatacenters(Handler<AsyncResult<List<String>>> resultHandler)` Return all the datacenters that are known by the Consul server
    `Future<NodeList>` | `catalogNodes()` Like `catalogNodes(Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `catalogNodes(Handler<AsyncResult<NodeList>> resultHandler)` Returns the nodes registered in a datacenter
    `Future<ServiceList>` | `catalogNodeServices(String node)` Like `catalogNodeServices(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `catalogNodeServices(String node, Handler<AsyncResult<ServiceList>> resultHandler)` Returns the node's registered services
    `Future<ServiceList>` | `catalogNodeServicesWithOptions(String node, BlockingQueryOptions options)` Like `catalogNodeServicesWithOptions(String, BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `catalogNodeServicesWithOptions(String node, BlockingQueryOptions options, Handler<AsyncResult<ServiceList>> resultHandler)` Returns the node's registered services This is blocking query unlike `catalogNodeServices(String, Handler)`
    `Future<NodeList>` | `catalogNodesWithOptions(NodeQueryOptions options)` Like `catalogNodesWithOptions(NodeQueryOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `catalogNodesWithOptions(NodeQueryOptions options, Handler<AsyncResult<NodeList>> resultHandler)` Returns the nodes registered in a datacenter
    `Future<ServiceList>` | `catalogServiceNodes(String service)` Like `catalogServiceNodes(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `catalogServiceNodes(String service, Handler<AsyncResult<ServiceList>> resultHandler)` Returns the nodes providing a service
    `Future<ServiceList>` | `catalogServiceNodesWithOptions(String service, ServiceQueryOptions options)` Like `catalogServiceNodesWithOptions(String, ServiceQueryOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `catalogServiceNodesWithOptions(String service, ServiceQueryOptions options, Handler<AsyncResult<ServiceList>> resultHandler)` Returns the nodes providing a service
    `Future<ServiceList>` | `catalogServices()` Like `catalogServices(Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `catalogServices(Handler<AsyncResult<ServiceList>> resultHandler)` Returns the services registered in a datacenter
    `Future<ServiceList>` | `catalogServicesWithOptions(BlockingQueryOptions options)` Like `catalogServicesWithOptions(BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `catalogServicesWithOptions(BlockingQueryOptions options, Handler<AsyncResult<ServiceList>> resultHandler)` Returns the services registered in a datacenter This is blocking query unlike `catalogServices(Handler)`
    `Future<String>` | `cloneAclToken(String id)` Deprecated.
    `Future<AclToken>` | `cloneAclToken(String accessorId, CloneAclTokenOptions cloneAclTokenOptions)` Clones an existing ACL token
    `ConsulClient` | `cloneAclToken(String accessorId, CloneAclTokenOptions cloneAclToken, Handler<AsyncResult<AclToken>> resultHandler)` Clones an existing ACL token
    `ConsulClient` | `cloneAclToken(String id, Handler<AsyncResult<String>> idHandler)` Deprecated. Use `cloneAclToken(String, CloneAclTokenOptions)` instead
    `void` | `close()` Close the client and release its resources
    `Future<List<DcCoordinates>>` | `coordinateDatacenters()` Like `coordinateDatacenters(Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `coordinateDatacenters(Handler<AsyncResult<List<DcCoordinates>>> resultHandler)` Returns the WAN network coordinates for all Consul servers, organized by DCs
    `Future<CoordinateList>` | `coordinateNodes()` Like `coordinateNodes(Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `coordinateNodes(Handler<AsyncResult<CoordinateList>> resultHandler)` Returns the LAN network coordinates for all nodes in a given DC
    `Future<CoordinateList>` | `coordinateNodesWithOptions(BlockingQueryOptions options)` Like `coordinateNodesWithOptions(BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `coordinateNodesWithOptions(BlockingQueryOptions options, Handler<AsyncResult<CoordinateList>> resultHandler)` Returns the LAN network coordinates for all nodes in a given DC This is blocking query unlike `coordinateNodes(Handler)`
    `static ConsulClient` | `create(Vertx vertx)` Create a Consul client with default options.
    `static ConsulClient` | `create(Vertx vertx, ConsulClientOptions options)` Create a Consul client.
    `Future<String>` | `createAclPolicy(AclPolicy policy)` Creates a new ACL policy
    `ConsulClient` | `createAclPolicy(AclPolicy policy, Handler<AsyncResult<String>> resultHandler)` Creates a new ACL policy
    `Future<AclToken>` | `createAclToken(AclToken token)` Create an Acl token
    `Future<String>` | `createAclToken(AclToken token)` Deprecated.
    `ConsulClient` | `createAclToken(AclToken token, Handler<AsyncResult<AclToken>> resultHandler)` Create an Acl token
    `ConsulClient` | `createAclToken(AclToken token, Handler<AsyncResult<String>> idHandler)` Deprecated. Use `createAclToken(io.vertx.ext.consul.token.AclToken)` instead
    `Future<String>` | `createPreparedQuery(PreparedQueryDefinition definition)` Like `createPreparedQuery(PreparedQueryDefinition, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `createPreparedQuery(PreparedQueryDefinition definition, Handler<AsyncResult<String>> resultHandler)`
    `Future<String>` | `createSession()` Like `createSession(Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `createSession(Handler<AsyncResult<String>> idHandler)` Initialize a new session
    `Future<String>` | `createSessionWithOptions(SessionOptions options)` Like `createSessionWithOptions(SessionOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `createSessionWithOptions(SessionOptions options, Handler<AsyncResult<String>> idHandler)` Initialize a new session
    `Future<Boolean>` | `deleteAclToken(String accessorId)` Deletes an ACL token
    `ConsulClient` | `deleteAclToken(String accessorId, Handler<AsyncResult<Boolean>> resultHandler)` Deletes an ACL token
    `Future<Boolean>` | `deletePolicy(String id)` This endpoint deletes an ACL policy
    `ConsulClient` | `deletePolicy(String id, Handler<AsyncResult<Boolean>> resultHandler)` This endpoint deletes an ACL policy
    `Future<Void>` | `deletePreparedQuery(String id)` Like `deletePreparedQuery(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `deletePreparedQuery(String id, Handler<AsyncResult<Void>> resultHandler)` Deletes an existing prepared query
    `Future<Void>` | `deleteValue(String key)` Like `deleteValue(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `deleteValue(String key, Handler<AsyncResult<Void>> resultHandler)` Remove the key/value pair that corresponding to the specified key
    `Future<Void>` | `deleteValues(String keyPrefix)` Like `deleteValues(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `deleteValues(String keyPrefix, Handler<AsyncResult<Void>> resultHandler)` Removes all the key/value pair that corresponding to the specified key prefix
    `ConsulClient` | `deregisterCatalogService(String nodeId, String serviceId, Handler<AsyncResult<Void>> resultHandler)` Deregister entities from the node or deregister the node itself.
    `Future<Void>` | `deregisterCheck(String checkId)` Like `deregisterCheck(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `deregisterCheck(String checkId, Handler<AsyncResult<Void>> resultHandler)` Remove a check from the local agent.
    `Future<Void>` | `deregisterService(String id)` Like `deregisterService(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `deregisterService(String id, Handler<AsyncResult<Void>> resultHandler)` Remove a service from the local agent.
    `Future<Void>` | `destroyAclToken(String id)` Deprecated.
    `ConsulClient` | `destroyAclToken(String id, Handler<AsyncResult<Void>> resultHandler)` Deprecated. Use `deleteAclToken(String)` instead
    `Future<Void>` | `destroySession(String id)` Like `destroySession(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `destroySession(String id, Handler<AsyncResult<Void>> resultHandler)` Destroys the given session
    `Future<PreparedQueryExecuteResponse>` | `executePreparedQuery(String query)` Like `executePreparedQuery(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `executePreparedQuery(String query, Handler<AsyncResult<PreparedQueryExecuteResponse>> resultHandler)` Executes an existing prepared query.
    `Future<PreparedQueryExecuteResponse>` | `executePreparedQueryWithOptions(String query, PreparedQueryExecuteOptions options)` Like `executePreparedQueryWithOptions(String, PreparedQueryExecuteOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `executePreparedQueryWithOptions(String query, PreparedQueryExecuteOptions options, Handler<AsyncResult<PreparedQueryExecuteResponse>> resultHandler)` Executes an existing prepared query.
    `Future<Void>` | `failCheck(String checkId)` Like `failCheck(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `failCheck(String checkId, Handler<AsyncResult<Void>> resultHandler)` Set status of the check to "critical".
    `Future<Void>` | `failCheckWithNote(String checkId, String note)` Like `failCheckWithNote(String, String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `failCheckWithNote(String checkId, String note, Handler<AsyncResult<Void>> resultHandler)` Set status of the check to "critical".
    `Future<Event>` | `fireEvent(String name)` Like `fireEvent(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `fireEvent(String name, Handler<AsyncResult<Event>> resultHandler)` Fires a new user event
    `Future<Event>` | `fireEventWithOptions(String name, EventOptions options)` Like `fireEventWithOptions(String, EventOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `fireEventWithOptions(String name, EventOptions options, Handler<AsyncResult<Event>> resultHandler)` Fires a new user event
    `Future<List<AclPolicy>>` | `getAclPolicies()` This endpoint lists all the ACL policies.
    `ConsulClient` | `getAclPolicies(Handler<AsyncResult<List<AclPolicy>>> resultHandler)` This endpoint lists all the ACL policies.
    `Future<List<AclToken>>` | `getAclTokens()` Get list of Acl token
    `ConsulClient` | `getAclTokens(Handler<AsyncResult<List<AclToken>>> resultHandler)` Get list of Acl token
    `Future<List<PreparedQueryDefinition>>` | `getAllPreparedQueries()` Like `getAllPreparedQueries(Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `getAllPreparedQueries(Handler<AsyncResult<List<PreparedQueryDefinition>>> resultHandler)` Returns a list of all prepared queries.
    `Future<List<String>>` | `getKeys(String keyPrefix)` Like `getKeys(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `getKeys(String keyPrefix, Handler<AsyncResult<List<String>>> resultHandler)` Returns the list of keys that corresponding to the specified key prefix.
    `Future<List<String>>` | `getKeysWithOptions(String keyPrefix, BlockingQueryOptions options)` Like `getKeysWithOptions(String, BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `getKeysWithOptions(String keyPrefix, BlockingQueryOptions options, Handler<AsyncResult<List<String>>> resultHandler)` Returns the list of keys that corresponding to the specified key prefix.
    `Future<PreparedQueryDefinition>` | `getPreparedQuery(String id)` Like `getPreparedQuery(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `getPreparedQuery(String id, Handler<AsyncResult<PreparedQueryDefinition>> resultHandler)` Returns an existing prepared query
    `Future<KeyValue>` | `getValue(String key)` Like `getValue(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `getValue(String key, Handler<AsyncResult<KeyValue>> resultHandler)` Returns key/value pair that corresponding to the specified key.
    `Future<KeyValueList>` | `getValues(String keyPrefix)` Like `getValues(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `getValues(String keyPrefix, Handler<AsyncResult<KeyValueList>> resultHandler)` Returns the list of key/value pairs that corresponding to the specified key prefix.
    `Future<KeyValueList>` | `getValuesWithOptions(String keyPrefix, BlockingQueryOptions options)` Like `getValuesWithOptions(String, BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `getValuesWithOptions(String keyPrefix, BlockingQueryOptions options, Handler<AsyncResult<KeyValueList>> resultHandler)` Returns the list of key/value pairs that corresponding to the specified key prefix.
    `Future<KeyValue>` | `getValueWithOptions(String key, BlockingQueryOptions options)` Like `getValueWithOptions(String, BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `getValueWithOptions(String key, BlockingQueryOptions options, Handler<AsyncResult<KeyValue>> resultHandler)` Returns key/value pair that corresponding to the specified key.
    `Future<CheckList>` | `healthChecks(String service)` Like `healthChecks(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `healthChecks(String service, Handler<AsyncResult<CheckList>> resultHandler)` Returns the checks associated with the service
    `Future<CheckList>` | `healthChecksWithOptions(String service, CheckQueryOptions options)` Like `healthChecksWithOptions(String, CheckQueryOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `healthChecksWithOptions(String service, CheckQueryOptions options, Handler<AsyncResult<CheckList>> resultHandler)` Returns the checks associated with the service
    `Future<CheckList>` | `healthNodesWithOptions(String node, CheckQueryOptions options)` Like `healthNodesWithOptions(String, CheckQueryOptions, Handler)` but returns a `Future` of the asynchronous result
    `ConsulClient` | `healthNodesWithOptions(String node, CheckQueryOptions options, Handler<AsyncResult<CheckList>> resultHandler)` Returns the checks specific to the node provided on the path.
    `Future<ServiceEntryList>` | `healthServiceNodes(String service, boolean passing)` Like `healthServiceNodes(String, boolean, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `healthServiceNodes(String service, boolean passing, Handler<AsyncResult<ServiceEntryList>> resultHandler)` Returns the nodes providing the service.
    `Future<ServiceEntryList>` | `healthServiceNodesWithOptions(String service, boolean passing, ServiceQueryOptions options)` Like `healthServiceNodesWithOptions(String, boolean, ServiceQueryOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `healthServiceNodesWithOptions(String service, boolean passing, ServiceQueryOptions options, Handler<AsyncResult<ServiceEntryList>> resultHandler)` Returns the nodes providing the service.
    `Future<CheckList>` | `healthState(HealthState healthState)` Like `healthState(HealthState, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `healthState(HealthState healthState, Handler<AsyncResult<CheckList>> resultHandler)` Returns the checks in the specified status
    `Future<CheckList>` | `healthStateWithOptions(HealthState healthState, CheckQueryOptions options)` Like `healthStateWithOptions(HealthState, CheckQueryOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `healthStateWithOptions(HealthState healthState, CheckQueryOptions options, Handler<AsyncResult<CheckList>> resultHandler)` Returns the checks in the specified status
    `Future<AclToken>` | `infoAclToken(String id)` Deprecated.
    `ConsulClient` | `infoAclToken(String id, Handler<AsyncResult<AclToken>> tokenHandler)` Deprecated. Use `readAclToken(String)` instead
    `Future<Session>` | `infoSession(String id)` Like `infoSession(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `infoSession(String id, Handler<AsyncResult<Session>> resultHandler)` Returns the requested session information
    `Future<Session>` | `infoSessionWithOptions(String id, BlockingQueryOptions options)` Like `infoSessionWithOptions(String, BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `infoSessionWithOptions(String id, BlockingQueryOptions options, Handler<AsyncResult<Session>> resultHandler)` Returns the requested session information This is blocking query unlike `infoSession(String, Handler)`
    `Future<String>` | `leaderStatus()` Like `leaderStatus(Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `leaderStatus(Handler<AsyncResult<String>> resultHandler)` Get the Raft leader for the datacenter in which the agent is running.
    `Future<List<AclToken>>` | `listAclTokens()` Deprecated.
    `ConsulClient` | `listAclTokens(Handler<AsyncResult<List<AclToken>>> resultHandler)` Deprecated. Use `getAclTokens()` instead
    `Future<EventList>` | `listEvents()` Like `listEvents(Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `listEvents(Handler<AsyncResult<EventList>> resultHandler)` Returns the most recent events known by the agent
    `Future<EventList>` | `listEventsWithOptions(EventListOptions options)` Like `listEventsWithOptions(EventListOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `listEventsWithOptions(EventListOptions options, Handler<AsyncResult<EventList>> resultHandler)` Returns the most recent events known by the agent.
    `Future<SessionList>` | `listNodeSessions(String nodeId)` Like `listNodeSessions(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `listNodeSessions(String nodeId, Handler<AsyncResult<SessionList>> resultHandler)` Returns the active sessions for a given node
    `Future<SessionList>` | `listNodeSessionsWithOptions(String nodeId, BlockingQueryOptions options)` Like `listNodeSessionsWithOptions(String, BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `listNodeSessionsWithOptions(String nodeId, BlockingQueryOptions options, Handler<AsyncResult<SessionList>> resultHandler)` Returns the active sessions for a given node This is blocking query unlike `listNodeSessions(String, Handler)`
    `Future<SessionList>` | `listSessions()` Like `listSessions(Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `listSessions(Handler<AsyncResult<SessionList>> resultHandler)` Returns the active sessions
    `Future<SessionList>` | `listSessionsWithOptions(BlockingQueryOptions options)` Like `listSessionsWithOptions(BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `listSessionsWithOptions(BlockingQueryOptions options, Handler<AsyncResult<SessionList>> resultHandler)` Returns the active sessions This is blocking query unlike `listSessions(Handler)`
    `Future<List<Check>>` | `localChecks()` Like `localChecks(Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `localChecks(Handler<AsyncResult<List<Check>>> resultHandler)` Return all the checks that are registered with the local agent.
    `Future<List<Service>>` | `localServices()` Like `localServices(Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `localServices(Handler<AsyncResult<List<Service>>> resultHandler)` Returns list of services registered with the local agent.
    `Future<Void>` | `maintenanceService(MaintenanceOptions maintenanceOptions)` Like `maintenanceService(MaintenanceOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `maintenanceService(MaintenanceOptions maintenanceOptions, Handler<AsyncResult<Void>> resultHandler)` Places a given service into "maintenance mode"
    `Future<Void>` | `passCheck(String checkId)` Like `passCheck(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `passCheck(String checkId, Handler<AsyncResult<Void>> resultHandler)` Set status of the check to "passing".
    `Future<Void>` | `passCheckWithNote(String checkId, String note)` Like `passCheckWithNote(String, String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `passCheckWithNote(String checkId, String note, Handler<AsyncResult<Void>> resultHandler)` Set status of the check to "passing".
    `Future<List<String>>` | `peersStatus()` Like `peersStatus(Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `peersStatus(Handler<AsyncResult<List<String>>> resultHandler)` Retrieves the Raft peers for the datacenter in which the the agent is running.
    `Future<Boolean>` | `putValue(String key, String value)` Like `putValue(String, String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `putValue(String key, String value, Handler<AsyncResult<Boolean>> resultHandler)` Adds specified key/value pair
    `Future<Boolean>` | `putValueWithOptions(String key, String value, KeyValueOptions options)` Like `putValueWithOptions(String, String, KeyValueOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `putValueWithOptions(String key, String value, KeyValueOptions options, Handler<AsyncResult<Boolean>> resultHandler)`
    `Future<AclToken>` | `readAclToken(String accessorId)` Reads an ACL token with the given Accessor ID
    `ConsulClient` | `readAclToken(String accessorId, Handler<AsyncResult<AclToken>> resultHandler)` Reads an ACL token with the given Accessor ID
    `Future<AclPolicy>` | `readPolicy(String id)` This endpoint reads an ACL policy with the given ID
    `ConsulClient` | `readPolicy(String id, Handler<AsyncResult<AclPolicy>> resultHandler)` This endpoint reads an ACL policy with the given ID
    `Future<AclPolicy>` | `readPolicyByName(String name)` This endpoint reads an ACL policy with the given name
    `ConsulClient` | `readPolicyByName(String name, Handler<AsyncResult<AclPolicy>> resultHandler)` This endpoint reads an ACL policy with the given name
    `ConsulClient` | `registerCatalogService(Node nodeOptions, ServiceOptions serviceOptions, Handler<AsyncResult<Void>> resultHandler)` Register node with external service
    `Future<Void>` | `registerCheck(CheckOptions checkOptions)` Like `registerCheck(CheckOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `registerCheck(CheckOptions checkOptions, Handler<AsyncResult<Void>> resultHandler)` Add a new check to the local agent.
    `Future<Void>` | `registerService(ServiceOptions serviceOptions)` Like `registerService(ServiceOptions, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `registerService(ServiceOptions serviceOptions, Handler<AsyncResult<Void>> resultHandler)` Adds a new service, with an optional health check, to the local agent.
    `Future<Session>` | `renewSession(String id)` Like `renewSession(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `renewSession(String id, Handler<AsyncResult<Session>> resultHandler)` Renews the given session.
    `Future<TxnResponse>` | `transaction(TxnRequest request)` Like `transaction(TxnRequest, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `transaction(TxnRequest request, Handler<AsyncResult<TxnResponse>> resultHandler)` Manages multiple operations inside a single, atomic transaction.
    `Future<String>` | `updateAclToken(AclToken token)` Deprecated.
    `ConsulClient` | `updateAclToken(AclToken token, Handler<AsyncResult<String>> idHandler)` Deprecated. Use `updateAclToken(String, io.vertx.ext.consul.token.AclToken)` instead
    `Future<AclToken>` | `updateAclToken(String accessorId, AclToken token)` Update an existing Acl token
    `ConsulClient` | `updateAclToken(String accessorId, AclToken token, Handler<AsyncResult<AclToken>> resultHandler)` Update an existing Acl token
    `Future<Void>` | `updateCheck(String checkId, CheckStatus status)` Like `updateCheck(String, CheckStatus, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `updateCheck(String checkId, CheckStatus status, Handler<AsyncResult<Void>> resultHandler)` Set status of the check to given status.
    `Future<Void>` | `updateCheckWithNote(String checkId, CheckStatus status, String note)` Like `updateCheckWithNote(String, CheckStatus, String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `updateCheckWithNote(String checkId, CheckStatus status, String note, Handler<AsyncResult<Void>> resultHandler)` Set status of the check to given status.
    `Future<AclPolicy>` | `updatePolicy(String id, AclPolicy policy)` This endpoint updates an existing ACL policy
    `ConsulClient` | `updatePolicy(String id, AclPolicy policy, Handler<AsyncResult<AclPolicy>> resultHandler)` This endpoint updates an existing ACL policy
    `Future<Void>` | `updatePreparedQuery(PreparedQueryDefinition definition)` Like `updatePreparedQuery(PreparedQueryDefinition, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `updatePreparedQuery(PreparedQueryDefinition definition, Handler<AsyncResult<Void>> resultHandler)`
    `Future<Void>` | `warnCheck(String checkId)` Like `warnCheck(String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `warnCheck(String checkId, Handler<AsyncResult<Void>> resultHandler)` Set status of the check to "warning".
    `Future<Void>` | `warnCheckWithNote(String checkId, String note)` Like `warnCheckWithNote(String, String, Handler)` but returns a `Future` of the asynchronous result.
    `ConsulClient` | `warnCheckWithNote(String checkId, String note, Handler<AsyncResult<Void>> resultHandler)` Set status of the check to "warning".

- - ### Method Detail

    - #### create

          static ConsulClient create(Vertx vertx)

      Create a Consul client with default options.
      Parameters:
        `vertx` - the Vert.x instance
      Returns:
        the client

    - #### create

          static ConsulClient create(Vertx vertx,
                                     ConsulClientOptions options)

      Create a Consul client.
      Parameters:
        `vertx` - the Vert.x instance
        `options` - the options
      Returns:
        the client

    - #### agentInfo

          ConsulClient agentInfo(Handler<AsyncResult<JsonObject>> resultHandler)

      Returns the configuration and member information of the local agent
      Parameters:
        `resultHandler` - will be provided with the configuration and member information of the local agent
      Returns:
        reference to this, for fluency
      See Also:
        /v1/agent/self endpoint

    - #### agentInfo

          Future<JsonObject> agentInfo()

      Like `agentInfo(Handler)` but returns a `Future` of the asynchronous result.

    - #### coordinateNodes

          ConsulClient coordinateNodes(Handler<AsyncResult<CoordinateList>> resultHandler)

      Returns the LAN network coordinates for all nodes in a given DC
      Parameters:
        `resultHandler` - will be provided with network coordinates of nodes in datacenter
      Returns:
        reference to this, for fluency
      See Also:
        /v1/coordinate/nodes endpoint

    - #### coordinateNodes

          Future<CoordinateList> coordinateNodes()

      Like `coordinateNodes(Handler)` but returns a `Future` of the asynchronous result.

    - #### coordinateNodesWithOptions

          ConsulClient coordinateNodesWithOptions(BlockingQueryOptions options,
                                                  Handler<AsyncResult<CoordinateList>> resultHandler)

      Returns the LAN network coordinates for all nodes in a given DC This is blocking query unlike `coordinateNodes(Handler)`
      Parameters:
        `options` - the blocking options
        `resultHandler` - will be provided with network coordinates of nodes in datacenter
      Returns:
        reference to this, for fluency
      See Also:
        /v1/coordinate/nodes endpoint

    - #### coordinateNodesWithOptions

          Future<CoordinateList> coordinateNodesWithOptions(BlockingQueryOptions options)

      Like `coordinateNodesWithOptions(BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### coordinateDatacenters

          ConsulClient coordinateDatacenters(Handler<AsyncResult<List<DcCoordinates>>> resultHandler)

      Returns the WAN network coordinates for all Consul servers, organized by DCs
      Parameters:
        `resultHandler` - will be provided with network coordinates for all Consul servers
      Returns:
        reference to this, for fluency
      See Also:
        /v1/coordinate/datacenters endpoint

    - #### coordinateDatacenters

          Future<List<DcCoordinates>> coordinateDatacenters()

      Like `coordinateDatacenters(Handler)` but returns a `Future` of the asynchronous result.

    - #### getKeys

          ConsulClient getKeys(String keyPrefix,
                               Handler<AsyncResult<List<String>>> resultHandler)

      Returns the list of keys that corresponding to the specified key prefix.
      Parameters:
        `keyPrefix` - the prefix
        `resultHandler` - will be provided with keys list
      Returns:
        reference to this, for fluency
      See Also:
        /v1/kv/:key endpoint

    - #### getKeys

          Future<List<String>> getKeys(String keyPrefix)

      Like `getKeys(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### getKeysWithOptions

          ConsulClient getKeysWithOptions(String keyPrefix,
                                          BlockingQueryOptions options,
                                          Handler<AsyncResult<List<String>>> resultHandler)

      Returns the list of keys that corresponding to the specified key prefix.
      Parameters:
        `keyPrefix` - the prefix
        `options` - the blocking options
        `resultHandler` - will be provided with keys list
      Returns:
        reference to this, for fluency
      See Also:
        /v1/kv/:key endpoint

    - #### getKeysWithOptions

          Future<List<String>> getKeysWithOptions(String keyPrefix,
                                                  BlockingQueryOptions options)

      Like `getKeysWithOptions(String, BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### getValue

          ConsulClient getValue(String key,
                                Handler<AsyncResult<KeyValue>> resultHandler)

      Returns key/value pair that corresponding to the specified key. An empty `KeyValue` object will be returned if no such key is found.
      Parameters:
        `key` - the key
        `resultHandler` - will be provided with key/value pair
      Returns:
        reference to this, for fluency
      See Also:
        /v1/kv/:key endpoint

    - #### getValue

          Future<KeyValue> getValue(String key)

      Like `getValue(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### getValueWithOptions

          ConsulClient getValueWithOptions(String key,
                                           BlockingQueryOptions options,
                                           Handler<AsyncResult<KeyValue>> resultHandler)

      Returns key/value pair that corresponding to the specified key. An empty `KeyValue` object will be returned if no such key is found. This is blocking query unlike `getValue(String, Handler)`
      Parameters:
        `key` - the key
        `options` - the blocking options
        `resultHandler` - will be provided with key/value pair
      Returns:
        reference to this, for fluency
      See Also:
        /v1/kv/:key endpoint

    - #### getValueWithOptions

          Future<KeyValue> getValueWithOptions(String key,
                                               BlockingQueryOptions options)

      Like `getValueWithOptions(String, BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### deleteValue

          ConsulClient deleteValue(String key,
                                   Handler<AsyncResult<Void>> resultHandler)

      Remove the key/value pair that corresponding to the specified key
      Parameters:
        `key` - the key
        `resultHandler` - will be called on complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/kv/:key endpoint

    - #### deleteValue

          Future<Void> deleteValue(String key)

      Like `deleteValue(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### getValues

          ConsulClient getValues(String keyPrefix,
                                 Handler<AsyncResult<KeyValueList>> resultHandler)

      Returns the list of key/value pairs that corresponding to the specified key prefix. An empty `KeyValueList` object will be returned if no such key prefix is found.
      Parameters:
        `keyPrefix` - the prefix
        `resultHandler` - will be provided with list of key/value pairs
      Returns:
        reference to this, for fluency
      See Also:
        /v1/kv/:key endpoint

    - #### getValues

          Future<KeyValueList> getValues(String keyPrefix)

      Like `getValues(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### getValuesWithOptions

          ConsulClient getValuesWithOptions(String keyPrefix,
                                            BlockingQueryOptions options,
                                            Handler<AsyncResult<KeyValueList>> resultHandler)

      Returns the list of key/value pairs that corresponding to the specified key prefix. An empty `KeyValueList` object will be returned if no such key prefix is found. This is blocking query unlike `getValues(String, Handler)`
      Parameters:
        `keyPrefix` - the prefix
        `options` - the blocking options
        `resultHandler` - will be provided with list of key/value pairs
      Returns:
        reference to this, for fluency
      See Also:
        /v1/kv/:key endpoint

    - #### getValuesWithOptions

          Future<KeyValueList> getValuesWithOptions(String keyPrefix,
                                                    BlockingQueryOptions options)

      Like `getValuesWithOptions(String, BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### deleteValues

          ConsulClient deleteValues(String keyPrefix,
                                    Handler<AsyncResult<Void>> resultHandler)

      Removes all the key/value pair that corresponding to the specified key prefix
      Parameters:
        `keyPrefix` - the prefix
        `resultHandler` - will be called on complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/kv/:key endpoint

    - #### deleteValues

          Future<Void> deleteValues(String keyPrefix)

      Like `deleteValues(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### putValue

          ConsulClient putValue(String key,
                                String value,
                                Handler<AsyncResult<Boolean>> resultHandler)

      Adds specified key/value pair
      Parameters:
        `key` - the key
        `value` - the value
        `resultHandler` - will be provided with success of operation
      Returns:
        reference to this, for fluency
      See Also:
        /v1/kv/:key endpoint

    - #### putValue

          Future<Boolean> putValue(String key,
                                   String value)

      Like `putValue(String, String, Handler)` but returns a `Future` of the asynchronous result.

    - #### putValueWithOptions

          ConsulClient putValueWithOptions(String key,
                                           String value,
                                           KeyValueOptions options,
                                           Handler<AsyncResult<Boolean>> resultHandler)

      Parameters:
        `key` - the key
        `value` - the value
        `options` - options used to push pair
        `resultHandler` - will be provided with success of operation
      Returns:
        reference to this, for fluency
      See Also:
        /v1/kv/:key endpoint

    - #### putValueWithOptions

          Future<Boolean> putValueWithOptions(String key,
                                              String value,
                                              KeyValueOptions options)

      Like `putValueWithOptions(String, String, KeyValueOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### transaction

          ConsulClient transaction(TxnRequest request,
                                   Handler<AsyncResult<TxnResponse>> resultHandler)

      Manages multiple operations inside a single, atomic transaction.
      Parameters:
        `request` - transaction request
        `resultHandler` - will be provided with result of transaction
      Returns:
        reference to this, for fluency
      See Also:
        /v1/txn endpoint

    - #### transaction

          Future<TxnResponse> transaction(TxnRequest request)

      Like `transaction(TxnRequest, Handler)` but returns a `Future` of the asynchronous result.

    - #### createAclPolicy

          ConsulClient createAclPolicy(AclPolicy policy,
                                       Handler<AsyncResult<String>> resultHandler)

      Creates a new ACL policy
      Parameters:
        `policy` - properties of policy
        `resultHandler` - will be provided with result of policy
      Returns:
        reference to this, for fluency
      See Also:
        /acl/policy

    - #### createAclPolicy

          Future<String> createAclPolicy(AclPolicy policy)

      Creates a new ACL policy
      Parameters:
        `policy` - properties of policy
      Returns:
        a future provided with ID of created policy
      See Also:
        /acl/policy

    - #### readPolicy

          ConsulClient readPolicy(String id,
                                  Handler<AsyncResult<AclPolicy>> resultHandler)

      This endpoint reads an ACL policy with the given ID
      Parameters:
        `id` - uuid policy
        `resultHandler` - will be provided with result of policy
      Returns:
        a reference to this, for fluency
      See Also:
        GET /v1/acl/policy/:id

    - #### readPolicy

          Future<AclPolicy> readPolicy(String id)

      This endpoint reads an ACL policy with the given ID
      Parameters:
        `id` - uuid policy
      Returns:
        a future of AclPolicy
      See Also:
        GET /v1/acl/policy/:id

    - #### readPolicyByName

          ConsulClient readPolicyByName(String name,
                                        Handler<AsyncResult<AclPolicy>> resultHandler)

      This endpoint reads an ACL policy with the given name
      Parameters:
        `name` - unique name of created policy
        `resultHandler` - will be provided with result of policy
      Returns:
        a reference to this, for fluency
      See Also:
        GET /v1/acl/policy/name/:name

    - #### readPolicyByName

          Future<AclPolicy> readPolicyByName(String name)

      This endpoint reads an ACL policy with the given name
      Parameters:
        `name` - unique name of created policy
      Returns:
        a future of AclPolicy like in `readPolicy(String)`
      See Also:
        GET /v1/acl/policy/name/:name

    - #### updatePolicy

          ConsulClient updatePolicy(String id,
                                    AclPolicy policy,
                                    Handler<AsyncResult<AclPolicy>> resultHandler)

      This endpoint updates an existing ACL policy
      Parameters:
        `id` - uuid of existing policy
        `policy` - options that will be applied to the existing policy
        `resultHandler` - will be provided with result of policy
      Returns:
        a reference to this, for fluency
      See Also:
        PUT /acl/policy/:id

    - #### updatePolicy

          Future<AclPolicy> updatePolicy(String id,
                                         AclPolicy policy)

      This endpoint updates an existing ACL policy
      Parameters:
        `id` - uuid of existing policy
        `policy` - options that will be applied to the existing policy
      Returns:
        a future of AclPolicy
      See Also:
        PUT /acl/policy/:id

    - #### deletePolicy

          ConsulClient deletePolicy(String id,
                                    Handler<AsyncResult<Boolean>> resultHandler)

      This endpoint deletes an ACL policy
      Parameters:
        `id` - uuid of existing policy
        `resultHandler` - will be provided with result of policy deleting
      Returns:
        a reference to this, for fluency
      See Also:
        DELETE /acl/policy/:id

    - #### deletePolicy

          Future<Boolean> deletePolicy(String id)

      This endpoint deletes an ACL policy
      Parameters:
        `id` - uuid of existing policy
      Returns:
        a future boolean value: true or false, indicating whether the deletion was successful
      See Also:
        DELETE /acl/policy/:id

    - #### getAclPolicies

          ConsulClient getAclPolicies(Handler<AsyncResult<List<AclPolicy>>> resultHandler)

      This endpoint lists all the ACL policies. Note - The policies rules are not included in the listing and must be retrieved by the policy reading endpoint
      Parameters:
        `resultHandler` - will be provided with result of policy deleting
      Returns:
        a reference to this, for fluency
      See Also:
        GET /acl/policies

    - #### getAclPolicies

          Future<List<AclPolicy>> getAclPolicies()

      This endpoint lists all the ACL policies. Note - The policies rules are not included in the listing and must be retrieved by the policy reading endpoint
      Returns:
        a future of all acl policies
      See Also:
        GET /acl/policies

    - #### createAclToken

          ConsulClient createAclToken(AclToken token,
                                      Handler<AsyncResult<AclToken>> resultHandler)

      Create an Acl token
      Parameters:
        `token` - properties of the token
        `resultHandler` - will be provided with result of token
      Returns:
        reference to this, for fluency `AclToken` accessorId - required in the URL path or JSON body for getting, updating and cloning token. `AclToken` secretId - using in `ConsulClientOptions.setAclToken(String)`.
      See Also:
        /v1/acl/create endpoint

    - #### createAclToken

          Future<AclToken> createAclToken(AclToken token)

      Create an Acl token
      Parameters:
        `token` - properties of the token
      Returns:
        a future NewAclToken in which two fields accessorId and secretId. `AclToken` accessorId - required in the URL path or JSON body for getting, updating and cloning token. `AclToken` secretId - using in `ConsulClientOptions.setAclToken(String)`.
      See Also:
        /v1/acl/create endpoint

    - #### updateAclToken

          ConsulClient updateAclToken(String accessorId,
                                      AclToken token,
                                      Handler<AsyncResult<AclToken>> resultHandler)

      Update an existing Acl token
      Parameters:
        `accessorId` - uuid of the token
        `token` - properties of the token
        `resultHandler` - will be provided with result of token
      Returns:
        reference to this, for fluency
      See Also:
        /acl/token/:accessorId endpoint

    - #### updateAclToken

          Future<AclToken> updateAclToken(String accessorId,
                                          AclToken token)

      Update an existing Acl token
      Parameters:
        `accessorId` - uuid of the token
        `token` - properties of the token
      Returns:
        a future NewAclToken like in `createAclToken(io.vertx.ext.consul.token.AclToken)`
      See Also:
        /acl/token/:accessorId endpoint

    - #### cloneAclToken

          ConsulClient cloneAclToken(String accessorId,
                                     CloneAclTokenOptions cloneAclToken,
                                     Handler<AsyncResult<AclToken>> resultHandler)

      Clones an existing ACL token
      Parameters:
        `accessorId` - uuid of the token
        `cloneAclToken` - properties of cloned token
        `resultHandler` - will be provided with result of token
      Returns:
        reference to this, for fluency
      See Also:
        /acl/token/:accessorId/clone endpoint

    - #### cloneAclToken

          Future<AclToken> cloneAclToken(String accessorId,
                                         CloneAclTokenOptions cloneAclTokenOptions)

      Clones an existing ACL token
      Parameters:
        `accessorId` - uuid of the token
        `cloneAclTokenOptions` - properties of cloned token
      Returns:
        a future NewAclToken like in `createAclToken(io.vertx.ext.consul.token.AclToken)`
      See Also:
        /acl/token/:accessorId/clone endpoint

    - #### getAclTokens

          ConsulClient getAclTokens(Handler<AsyncResult<List<AclToken>>> resultHandler)

      Get list of Acl token
      Parameters:
        `resultHandler` - will be provided with result of tokens
      Returns:
        reference to this, for fluency
      See Also:
        /v1/acl/tokens endpoint

    - #### getAclTokens

          Future<List<AclToken>> getAclTokens()

      Get list of Acl token
      Returns:
        a future provided with list of tokens
      See Also:
        /v1/acl/tokens endpoint

    - #### readAclToken

          ConsulClient readAclToken(String accessorId,
                                    Handler<AsyncResult<AclToken>> resultHandler)

      Reads an ACL token with the given Accessor ID
      Parameters:
        `accessorId` - uuid of token
        `resultHandler` - will be provided with result of token
      Returns:
        reference to this, for fluency
      See Also:
        /v1/acl/token/:AccessorID endpoint

    - #### readAclToken

          Future<AclToken> readAclToken(String accessorId)

      Reads an ACL token with the given Accessor ID
      Parameters:
        `accessorId` - uuid of token
      Returns:
        a future provided with token
      See Also:
        /v1/acl/token/:AccessorID endpoint

    - #### deleteAclToken

          ConsulClient deleteAclToken(String accessorId,
                                      Handler<AsyncResult<Boolean>> resultHandler)

      Deletes an ACL token
      Parameters:
        `accessorId` - uuid of token
        `resultHandler` - will be provided with result of token deleting
      Returns:
        reference to this, for fluency

    - #### deleteAclToken

          Future<Boolean> deleteAclToken(String accessorId)

      Deletes an ACL token
      Parameters:
        `accessorId` - uuid of token
      Returns:
        a future boolean value: true or false, indicating whether the deletion was successful.

    - #### createAclToken

          @Deprecated
          ConsulClient createAclToken(AclToken token,
                                                  Handler<AsyncResult<String>> idHandler)

      Deprecated. Use `createAclToken(io.vertx.ext.consul.token.AclToken)` instead
      Legacy create new Acl token
      Parameters:
        `token` - properties of the token
        `idHandler` - will be provided with ID of created token
      Returns:
        reference to this, for fluency
      See Also:
        /v1/acl/create endpoint

    - #### createAclToken

          @Deprecated
          Future<String> createAclToken(AclToken token)

      Deprecated.
      Like `createAclToken(AclToken, Handler)` but returns a `Future` of the asynchronous result.

    - #### updateAclToken

          @Deprecated
          ConsulClient updateAclToken(AclToken token,
                                                  Handler<AsyncResult<String>> idHandler)

      Deprecated. Use `updateAclToken(String, io.vertx.ext.consul.token.AclToken)` instead
      Update Acl token
      Parameters:
        `token` - properties of the token to be updated
        `idHandler` - will be provided with ID of updated
      Returns:
        reference to this, for fluency
      See Also:
        /v1/acl/update endpoint

    - #### updateAclToken

          @Deprecated
          Future<String> updateAclToken(AclToken token)

      Deprecated.
      Like `updateAclToken(AclToken, Handler)` but returns a `Future` of the asynchronous result.

    - #### cloneAclToken

          @Deprecated
          ConsulClient cloneAclToken(String id,
                                                 Handler<AsyncResult<String>> idHandler)

      Deprecated. Use `cloneAclToken(String, CloneAclTokenOptions)` instead
      Clone Acl token
      Parameters:
        `id` - the ID of token to be cloned
        `idHandler` - will be provided with ID of cloned token
      Returns:
        reference to this, for fluency
      See Also:
        /v1/acl/clone/:uuid endpoint

    - #### cloneAclToken

          @Deprecated
          Future<String> cloneAclToken(String id)

      Deprecated.
      Like `cloneAclToken(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### listAclTokens

          @Deprecated
          ConsulClient listAclTokens(Handler<AsyncResult<List<AclToken>>> resultHandler)

      Deprecated. Use `getAclTokens()` instead
      Get list of Acl token
      Parameters:
        `resultHandler` - will be provided with list of tokens
      Returns:
        reference to this, for fluency
      See Also:
        /v1/acl/list endpoint

    - #### listAclTokens

          @Deprecated
          Future<List<AclToken>> listAclTokens()

      Deprecated.
      Like `listAclTokens(Handler)` but returns a `Future` of the asynchronous result.

    - #### infoAclToken

          @Deprecated
          ConsulClient infoAclToken(String id,
                                                Handler<AsyncResult<AclToken>> tokenHandler)

      Deprecated. Use `readAclToken(String)` instead
      Get info of Acl token
      Parameters:
        `id` - the ID of token
        `tokenHandler` - will be provided with token
      Returns:
        reference to this, for fluency
      See Also:
        /v1/acl/info/:uuid endpoint

    - #### infoAclToken

          @Deprecated
          Future<AclToken> infoAclToken(String id)

      Deprecated.
      Like `infoAclToken(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### destroyAclToken

          @Deprecated
          ConsulClient destroyAclToken(String id,
                                                   Handler<AsyncResult<Void>> resultHandler)

      Deprecated. Use `deleteAclToken(String)` instead
      Destroy Acl token
      Parameters:
        `id` - the ID of token
        `resultHandler` - will be called on complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/acl/destroy/:uuid endpoint

    - #### destroyAclToken

          @Deprecated
          Future<Void> destroyAclToken(String id)

      Deprecated.
      Like `destroyAclToken(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### fireEvent

          ConsulClient fireEvent(String name,
                                 Handler<AsyncResult<Event>> resultHandler)

      Fires a new user event
      Parameters:
        `name` - name of event
        `resultHandler` - will be provided with properties of event
      Returns:
        reference to this, for fluency
      See Also:
        /v1/event/fire/:name endpoint

    - #### fireEvent

          Future<Event> fireEvent(String name)

      Like `fireEvent(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### fireEventWithOptions

          ConsulClient fireEventWithOptions(String name,
                                            EventOptions options,
                                            Handler<AsyncResult<Event>> resultHandler)

      Fires a new user event
      Parameters:
        `name` - name of event
        `options` - options used to create event
        `resultHandler` - will be provided with properties of event
      Returns:
        reference to this, for fluency
      See Also:
        /v1/event/fire/:name endpoint

    - #### fireEventWithOptions

          Future<Event> fireEventWithOptions(String name,
                                             EventOptions options)

      Like `fireEventWithOptions(String, EventOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### listEvents

          ConsulClient listEvents(Handler<AsyncResult<EventList>> resultHandler)

      Returns the most recent events known by the agent
      Parameters:
        `resultHandler` - will be provided with list of events
      Returns:
        reference to this, for fluency
      See Also:
        /v1/event/list endpoint

    - #### listEvents

          Future<EventList> listEvents()

      Like `listEvents(Handler)` but returns a `Future` of the asynchronous result.

    - #### listEventsWithOptions

          ConsulClient listEventsWithOptions(EventListOptions options,
                                             Handler<AsyncResult<EventList>> resultHandler)

      Returns the most recent events known by the agent. This is blocking query unlike `listEvents(Handler)`. However, the semantics of this endpoint are slightly different. Most blocking queries provide a monotonic index and block until a newer index is available. This can be supported as a consequence of the total ordering of the consensus protocol. With gossip, there is no ordering, and instead `X-Consul-Index` maps to the newest event that matches the query.

      In practice, this means the index is only useful when used against a single agent and has no meaning globally. Because Consul defines the index as being opaque, clients should not be expecting a natural ordering either.

      Parameters:
        `resultHandler` - will be provided with list of events
        `options` - the blocking options
      Returns:
        reference to this, for fluency
      See Also:
        /v1/event/list endpoint

    - #### listEventsWithOptions

          Future<EventList> listEventsWithOptions(EventListOptions options)

      Like `listEventsWithOptions(EventListOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### registerService

          ConsulClient registerService(ServiceOptions serviceOptions,
                                       Handler<AsyncResult<Void>> resultHandler)

      Adds a new service, with an optional health check, to the local agent.
      Parameters:
        `serviceOptions` - the options of new service
        `resultHandler` - will be called when complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/agent/service/register endpoint, `ServiceOptions`

    - #### registerService

          Future<Void> registerService(ServiceOptions serviceOptions)

      Like `registerService(ServiceOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### maintenanceService

          ConsulClient maintenanceService(MaintenanceOptions maintenanceOptions,
                                          Handler<AsyncResult<Void>> resultHandler)

      Places a given service into "maintenance mode"
      Parameters:
        `maintenanceOptions` - the maintenance options
        `resultHandler` - will be called when complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/agent/service/maintenance/:service_id endpoint, `MaintenanceOptions`

    - #### maintenanceService

          Future<Void> maintenanceService(MaintenanceOptions maintenanceOptions)

      Like `maintenanceService(MaintenanceOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### deregisterService

          ConsulClient deregisterService(String id,
                                         Handler<AsyncResult<Void>> resultHandler)

      Remove a service from the local agent. The agent will take care of deregistering the service with the Catalog. If there is an associated check, that is also deregistered.
      Parameters:
        `id` - the ID of service
        `resultHandler` - will be called when complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/agent/service/deregister/:service_id endpoint

    - #### deregisterService

          Future<Void> deregisterService(String id)

      Like `deregisterService(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### catalogServiceNodes

          ConsulClient catalogServiceNodes(String service,
                                           Handler<AsyncResult<ServiceList>> resultHandler)

      Returns the nodes providing a service
      Parameters:
        `service` - name of service
        `resultHandler` - will be provided with list of nodes providing given service
      Returns:
        reference to this, for fluency
      See Also:
        /v1/catalog/service/:service endpoint

    - #### catalogServiceNodes

          Future<ServiceList> catalogServiceNodes(String service)

      Like `catalogServiceNodes(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### catalogServiceNodesWithOptions

          ConsulClient catalogServiceNodesWithOptions(String service,
                                                      ServiceQueryOptions options,
                                                      Handler<AsyncResult<ServiceList>> resultHandler)

      Returns the nodes providing a service
      Parameters:
        `service` - name of service
        `options` - options used to request services
        `resultHandler` - will be provided with list of nodes providing given service
      Returns:
        reference to this, for fluency
      See Also:
        /v1/catalog/service/:service endpoint

    - #### catalogServiceNodesWithOptions

          Future<ServiceList> catalogServiceNodesWithOptions(String service,
                                                             ServiceQueryOptions options)

      Like `catalogServiceNodesWithOptions(String, ServiceQueryOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### catalogDatacenters

          ConsulClient catalogDatacenters(Handler<AsyncResult<List<String>>> resultHandler)

      Return all the datacenters that are known by the Consul server
      Parameters:
        `resultHandler` - will be provided with list of datacenters
      Returns:
        reference to this, for fluency
      See Also:
        /v1/catalog/datacenters endpoint

    - #### catalogDatacenters

          Future<List<String>> catalogDatacenters()

      Like `catalogDatacenters(Handler)` but returns a `Future` of the asynchronous result.

    - #### catalogNodes

          ConsulClient catalogNodes(Handler<AsyncResult<NodeList>> resultHandler)

      Returns the nodes registered in a datacenter
      Parameters:
        `resultHandler` - will be provided with list of nodes
      Returns:
        reference to this, for fluency
      See Also:
        /v1/catalog/nodes endpoint

    - #### catalogNodes

          Future<NodeList> catalogNodes()

      Like `catalogNodes(Handler)` but returns a `Future` of the asynchronous result.

    - #### catalogNodesWithOptions

          ConsulClient catalogNodesWithOptions(NodeQueryOptions options,
                                               Handler<AsyncResult<NodeList>> resultHandler)

      Returns the nodes registered in a datacenter
      Parameters:
        `resultHandler` - will be provided with list of nodes
        `options` - options used to request nodes
      Returns:
        reference to this, for fluency
      See Also:
        /v1/catalog/nodes endpoint

    - #### catalogNodesWithOptions

          Future<NodeList> catalogNodesWithOptions(NodeQueryOptions options)

      Like `catalogNodesWithOptions(NodeQueryOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### healthChecks

          ConsulClient healthChecks(String service,
                                    Handler<AsyncResult<CheckList>> resultHandler)

      Returns the checks associated with the service
      Parameters:
        `service` - the service name
        `resultHandler` - will be provided with list of checks
      Returns:
        reference to this, for fluency
      See Also:
        /v1/health/checks/:service endpoint

    - #### healthChecks

          Future<CheckList> healthChecks(String service)

      Like `healthChecks(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### healthChecksWithOptions

          ConsulClient healthChecksWithOptions(String service,
                                               CheckQueryOptions options,
                                               Handler<AsyncResult<CheckList>> resultHandler)

      Returns the checks associated with the service
      Parameters:
        `service` - the service name
        `options` - options used to request checks
        `resultHandler` - will be provided with list of checks
      Returns:
        reference to this, for fluency
      See Also:
        /v1/health/checks/:service endpoint

    - #### healthChecksWithOptions

          Future<CheckList> healthChecksWithOptions(String service,
                                                    CheckQueryOptions options)

      Like `healthChecksWithOptions(String, CheckQueryOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### healthState

          ConsulClient healthState(HealthState healthState,
                                   Handler<AsyncResult<CheckList>> resultHandler)

      Returns the checks in the specified status
      Parameters:
        `healthState` - the health state
        `resultHandler` - will be provided with list of checks
      Returns:
        reference to this, for fluency
      See Also:
        /v1/health/state/:state endpoint

    - #### healthState

          Future<CheckList> healthState(HealthState healthState)

      Like `healthState(HealthState, Handler)` but returns a `Future` of the asynchronous result.

    - #### healthStateWithOptions

          ConsulClient healthStateWithOptions(HealthState healthState,
                                              CheckQueryOptions options,
                                              Handler<AsyncResult<CheckList>> resultHandler)

      Returns the checks in the specified status
      Parameters:
        `healthState` - the health state
        `options` - options used to request checks
        `resultHandler` - will be provided with list of checks
      Returns:
        reference to this, for fluency
      See Also:
        /v1/health/state/:state endpoint

    - #### healthStateWithOptions

          Future<CheckList> healthStateWithOptions(HealthState healthState,
                                                   CheckQueryOptions options)

      Like `healthStateWithOptions(HealthState, CheckQueryOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### healthServiceNodes

          ConsulClient healthServiceNodes(String service,
                                          boolean passing,
                                          Handler<AsyncResult<ServiceEntryList>> resultHandler)

      Returns the nodes providing the service. This endpoint is very similar to the `catalogServiceNodes(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<io.vertx.ext.consul.ServiceList>>)` endpoint; however, this endpoint automatically returns the status of the associated health check as well as any system level health checks.
      Parameters:
        `service` - the service name
        `passing` - if true, filter results to only nodes with all checks in the passing state
        `resultHandler` - will be provided with list of services
      Returns:
        reference to this, for fluency
      See Also:
        /v1/health/service/:service endpoint

    - #### healthServiceNodes

          Future<ServiceEntryList> healthServiceNodes(String service,
                                                      boolean passing)

      Like `healthServiceNodes(String, boolean, Handler)` but returns a `Future` of the asynchronous result.

    - #### healthServiceNodesWithOptions

          ConsulClient healthServiceNodesWithOptions(String service,
                                                     boolean passing,
                                                     ServiceQueryOptions options,
                                                     Handler<AsyncResult<ServiceEntryList>> resultHandler)

      Returns the nodes providing the service. This endpoint is very similar to the `catalogServiceNodesWithOptions(java.lang.String, io.vertx.ext.consul.ServiceQueryOptions, io.vertx.core.Handler<io.vertx.core.AsyncResult<io.vertx.ext.consul.ServiceList>>)` endpoint; however, this endpoint automatically returns the status of the associated health check as well as any system level health checks.
      Parameters:
        `service` - the service name
        `passing` - if true, filter results to only nodes with all checks in the passing state
        `options` - options used to request services
        `resultHandler` - will be provided with list of services
      Returns:
        reference to this, for fluency
      See Also:
        /v1/health/service/:service endpoint

    - #### healthServiceNodesWithOptions

          Future<ServiceEntryList> healthServiceNodesWithOptions(String service,
                                                                 boolean passing,
                                                                 ServiceQueryOptions options)

      Like `healthServiceNodesWithOptions(String, boolean, ServiceQueryOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### healthNodesWithOptions

          ConsulClient healthNodesWithOptions(String node,
                                              CheckQueryOptions options,
                                              Handler<AsyncResult<CheckList>> resultHandler)

      Returns the checks specific to the node provided on the path.
      Parameters:
        `node` - the node name or ID
        `options` - options used to request node health checks
      Returns:
        a future provided with list of services
      See Also:
        /v1/health/node/:node endpoint

    - #### healthNodesWithOptions

          Future<CheckList> healthNodesWithOptions(String node,
                                                   CheckQueryOptions options)

      Like `healthNodesWithOptions(String, CheckQueryOptions, Handler)` but returns a `Future` of the asynchronous result

    - #### catalogServices

          ConsulClient catalogServices(Handler<AsyncResult<ServiceList>> resultHandler)

      Returns the services registered in a datacenter
      Parameters:
        `resultHandler` - will be provided with list of services
      Returns:
        reference to this, for fluency
      See Also:
        /v1/catalog/services endpoint

    - #### catalogServices

          Future<ServiceList> catalogServices()

      Like `catalogServices(Handler)` but returns a `Future` of the asynchronous result.

    - #### catalogServicesWithOptions

          ConsulClient catalogServicesWithOptions(BlockingQueryOptions options,
                                                  Handler<AsyncResult<ServiceList>> resultHandler)

      Returns the services registered in a datacenter This is blocking query unlike `catalogServices(Handler)`
      Parameters:
        `resultHandler` - will be provided with list of services
        `options` - the blocking options
      Returns:
        reference to this, for fluency
      See Also:
        /v1/catalog/services endpoint

    - #### catalogServicesWithOptions

          Future<ServiceList> catalogServicesWithOptions(BlockingQueryOptions options)

      Like `catalogServicesWithOptions(BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### catalogNodeServices

          ConsulClient catalogNodeServices(String node,
                                           Handler<AsyncResult<ServiceList>> resultHandler)

      Returns the node's registered services
      Parameters:
        `node` - node name
        `resultHandler` - will be provided with list of services
      Returns:
        reference to this, for fluency
      See Also:
        /v1/catalog/node/:node endpoint

    - #### catalogNodeServices

          Future<ServiceList> catalogNodeServices(String node)

      Like `catalogNodeServices(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### catalogNodeServicesWithOptions

          ConsulClient catalogNodeServicesWithOptions(String node,
                                                      BlockingQueryOptions options,
                                                      Handler<AsyncResult<ServiceList>> resultHandler)

      Returns the node's registered services This is blocking query unlike `catalogNodeServices(String, Handler)`
      Parameters:
        `node` - node name
        `options` - the blocking options
        `resultHandler` - will be provided with list of services
      Returns:
        reference to this, for fluency
      See Also:
        /v1/catalog/node/:node endpoint

    - #### catalogNodeServicesWithOptions

          Future<ServiceList> catalogNodeServicesWithOptions(String node,
                                                             BlockingQueryOptions options)

      Like `catalogNodeServicesWithOptions(String, BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### localServices

          ConsulClient localServices(Handler<AsyncResult<List<Service>>> resultHandler)

      Returns list of services registered with the local agent.
      Parameters:
        `resultHandler` - will be provided with list of services
      Returns:
        reference to this, for fluency
      See Also:
        /v1/agent/services endpoint

    - #### localServices

          Future<List<Service>> localServices()

      Like `localServices(Handler)` but returns a `Future` of the asynchronous result.

    - #### localChecks

          ConsulClient localChecks(Handler<AsyncResult<List<Check>>> resultHandler)

      Return all the checks that are registered with the local agent.
      Parameters:
        `resultHandler` - will be provided with list of checks
      Returns:
        reference to this, for fluency
      See Also:
        /v1/agent/checks endpoint

    - #### localChecks

          Future<List<Check>> localChecks()

      Like `localChecks(Handler)` but returns a `Future` of the asynchronous result.

    - #### registerCheck

          ConsulClient registerCheck(CheckOptions checkOptions,
                                     Handler<AsyncResult<Void>> resultHandler)

      Add a new check to the local agent. The agent is responsible for managing the status of the check and keeping the Catalog in sync.
      Parameters:
        `checkOptions` - options used to register new check
        `resultHandler` - will be called when complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/agent/check/register endpoint

    - #### registerCheck

          Future<Void> registerCheck(CheckOptions checkOptions)

      Like `registerCheck(CheckOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### deregisterCheck

          ConsulClient deregisterCheck(String checkId,
                                       Handler<AsyncResult<Void>> resultHandler)

      Remove a check from the local agent. The agent will take care of deregistering the check from the Catalog.
      Parameters:
        `checkId` - the ID of check
        `resultHandler` - will be called when complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/agent/check/deregister/:check_id endpoint

    - #### deregisterCheck

          Future<Void> deregisterCheck(String checkId)

      Like `deregisterCheck(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### passCheck

          ConsulClient passCheck(String checkId,
                                 Handler<AsyncResult<Void>> resultHandler)

      Set status of the check to "passing". Used with a check that is of the TTL type. The TTL clock will be reset.
      Parameters:
        `checkId` - the ID of check
        `resultHandler` - will be called when complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/agent/check/pass/:check_id endpoint, `CheckStatus`

    - #### passCheck

          Future<Void> passCheck(String checkId)

      Like `passCheck(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### passCheckWithNote

          ConsulClient passCheckWithNote(String checkId,
                                         String note,
                                         Handler<AsyncResult<Void>> resultHandler)

      Set status of the check to "passing". Used with a check that is of the TTL type. The TTL clock will be reset.
      Parameters:
        `checkId` - the ID of check
        `note` - specifies a human-readable message. This will be passed through to the check's `Output` field.
        `resultHandler` - will be called when complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/agent/check/pass/:check_id endpoint, `CheckStatus`

    - #### passCheckWithNote

          Future<Void> passCheckWithNote(String checkId,
                                         String note)

      Like `passCheckWithNote(String, String, Handler)` but returns a `Future` of the asynchronous result.

    - #### warnCheck

          ConsulClient warnCheck(String checkId,
                                 Handler<AsyncResult<Void>> resultHandler)

      Set status of the check to "warning". Used with a check that is of the TTL type. The TTL clock will be reset.
      Parameters:
        `checkId` - the ID of check
        `resultHandler` - will be called when complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/agent/check/warn/:check_id endpoint, `CheckStatus`

    - #### warnCheck

          Future<Void> warnCheck(String checkId)

      Like `warnCheck(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### warnCheckWithNote

          ConsulClient warnCheckWithNote(String checkId,
                                         String note,
                                         Handler<AsyncResult<Void>> resultHandler)

      Set status of the check to "warning". Used with a check that is of the TTL type. The TTL clock will be reset.
      Parameters:
        `checkId` - the ID of check
        `note` - specifies a human-readable message. This will be passed through to the check's `Output` field.
        `resultHandler` - will be called when complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/agent/check/warn/:check_id endpoint, `CheckStatus`

    - #### warnCheckWithNote

          Future<Void> warnCheckWithNote(String checkId,
                                         String note)

      Like `warnCheckWithNote(String, String, Handler)` but returns a `Future` of the asynchronous result.

    - #### failCheck

          ConsulClient failCheck(String checkId,
                                 Handler<AsyncResult<Void>> resultHandler)

      Set status of the check to "critical". Used with a check that is of the TTL type. The TTL clock will be reset.
      Parameters:
        `checkId` - the ID of check
        `resultHandler` - will be called when complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/agent/check/fail/:check_id endpoint, `CheckStatus`

    - #### failCheck

          Future<Void> failCheck(String checkId)

      Like `failCheck(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### failCheckWithNote

          ConsulClient failCheckWithNote(String checkId,
                                         String note,
                                         Handler<AsyncResult<Void>> resultHandler)

      Set status of the check to "critical". Used with a check that is of the TTL type. The TTL clock will be reset.
      Parameters:
        `checkId` - the ID of check
        `note` - specifies a human-readable message. This will be passed through to the check's `Output` field.
        `resultHandler` - will be called when complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/agent/check/fail/:check_id endpoint, `CheckStatus`

    - #### failCheckWithNote

          Future<Void> failCheckWithNote(String checkId,
                                         String note)

      Like `failCheckWithNote(String, String, Handler)` but returns a `Future` of the asynchronous result.

    - #### updateCheck

          ConsulClient updateCheck(String checkId,
                                   CheckStatus status,
                                   Handler<AsyncResult<Void>> resultHandler)

      Set status of the check to given status. Used with a check that is of the TTL type. The TTL clock will be reset.
      Parameters:
        `checkId` - the ID of check
        `status` - new status of check
        `resultHandler` - will be called when complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/agent/check/update/:check_id endpoint

    - #### updateCheck

          Future<Void> updateCheck(String checkId,
                                   CheckStatus status)

      Like `updateCheck(String, CheckStatus, Handler)` but returns a `Future` of the asynchronous result.

    - #### updateCheckWithNote

          ConsulClient updateCheckWithNote(String checkId,
                                           CheckStatus status,
                                           String note,
                                           Handler<AsyncResult<Void>> resultHandler)

      Set status of the check to given status. Used with a check that is of the TTL type. The TTL clock will be reset.
      Parameters:
        `checkId` - the ID of check
        `status` - new status of check
        `note` - specifies a human-readable message. This will be passed through to the check's `Output` field.
        `resultHandler` - will be called when complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/agent/check/update/:check_id endpoint

    - #### updateCheckWithNote

          Future<Void> updateCheckWithNote(String checkId,
                                           CheckStatus status,
                                           String note)

      Like `updateCheckWithNote(String, CheckStatus, String, Handler)` but returns a `Future` of the asynchronous result.

    - #### leaderStatus

          ConsulClient leaderStatus(Handler<AsyncResult<String>> resultHandler)

      Get the Raft leader for the datacenter in which the agent is running. It returns an address in format "`10.1.10.12:8300`"
      Parameters:
        `resultHandler` - will be provided with address of cluster leader
      Returns:
        reference to this, for fluency
      See Also:
        /v1/status/leader endpoint

    - #### leaderStatus

          Future<String> leaderStatus()

      Like `leaderStatus(Handler)` but returns a `Future` of the asynchronous result.
      Returns:

    - #### peersStatus

          ConsulClient peersStatus(Handler<AsyncResult<List<String>>> resultHandler)

      Retrieves the Raft peers for the datacenter in which the the agent is running. It returns a list of addresses "`10.1.10.12:8300`", "`10.1.10.13:8300`"
      Parameters:
        `resultHandler` - will be provided with list of peers
      Returns:
        reference to this, for fluency
      See Also:
        /v1/status/peers endpoint

    - #### peersStatus

          Future<List<String>> peersStatus()

      Like `peersStatus(Handler)` but returns a `Future` of the asynchronous result.

    - #### createSession

          ConsulClient createSession(Handler<AsyncResult<String>> idHandler)

      Initialize a new session
      Parameters:
        `idHandler` - will be provided with ID of new session
      Returns:
        reference to this, for fluency
      See Also:
        /v1/session/create endpoint

    - #### createSession

          Future<String> createSession()

      Like `createSession(Handler)` but returns a `Future` of the asynchronous result.

    - #### createSessionWithOptions

          ConsulClient createSessionWithOptions(SessionOptions options,
                                                Handler<AsyncResult<String>> idHandler)

      Initialize a new session
      Parameters:
        `options` - options used to create session
        `idHandler` - will be provided with ID of new session
      Returns:
        reference to this, for fluency
      See Also:
        /v1/session/create endpoint

    - #### createSessionWithOptions

          Future<String> createSessionWithOptions(SessionOptions options)

      Like `createSessionWithOptions(SessionOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### infoSession

          ConsulClient infoSession(String id,
                                   Handler<AsyncResult<Session>> resultHandler)

      Returns the requested session information
      Parameters:
        `id` - the ID of requested session
        `resultHandler` - will be provided with info of requested session
      Returns:
        reference to this, for fluency
      See Also:
        /v1/session/info/:uuid endpoint

    - #### infoSession

          Future<Session> infoSession(String id)

      Like `infoSession(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### infoSessionWithOptions

          ConsulClient infoSessionWithOptions(String id,
                                              BlockingQueryOptions options,
                                              Handler<AsyncResult<Session>> resultHandler)

      Returns the requested session information This is blocking query unlike `infoSession(String, Handler)`
      Parameters:
        `id` - the ID of requested session
        `options` - the blocking options
        `resultHandler` - will be provided with info of requested session
      Returns:
        reference to this, for fluency
      See Also:
        /v1/session/info/:uuid endpoint

    - #### infoSessionWithOptions

          Future<Session> infoSessionWithOptions(String id,
                                                 BlockingQueryOptions options)

      Like `infoSessionWithOptions(String, BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### renewSession

          ConsulClient renewSession(String id,
                                    Handler<AsyncResult<Session>> resultHandler)

      Renews the given session. This is used with sessions that have a TTL, and it extends the expiration by the TTL
      Parameters:
        `id` - the ID of session that should be renewed
        `resultHandler` - will be provided with info of renewed session
      Returns:
        reference to this, for fluency
      See Also:
        /v1/session/renew/:uuid endpoint

    - #### renewSession

          Future<Session> renewSession(String id)

      Like `renewSession(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### listSessions

          ConsulClient listSessions(Handler<AsyncResult<SessionList>> resultHandler)

      Returns the active sessions
      Parameters:
        `resultHandler` - will be provided with list of sessions
      Returns:
        reference to this, for fluency
      See Also:
        /v1/session/list endpoint

    - #### listSessions

          Future<SessionList> listSessions()

      Like `listSessions(Handler)` but returns a `Future` of the asynchronous result.

    - #### listSessionsWithOptions

          ConsulClient listSessionsWithOptions(BlockingQueryOptions options,
                                               Handler<AsyncResult<SessionList>> resultHandler)

      Returns the active sessions This is blocking query unlike `listSessions(Handler)`
      Parameters:
        `options` - the blocking options
        `resultHandler` - will be provided with list of sessions
      Returns:
        reference to this, for fluency
      See Also:
        /v1/session/list endpoint

    - #### listSessionsWithOptions

          Future<SessionList> listSessionsWithOptions(BlockingQueryOptions options)

      Like `listSessionsWithOptions(BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### listNodeSessions

          ConsulClient listNodeSessions(String nodeId,
                                        Handler<AsyncResult<SessionList>> resultHandler)

      Returns the active sessions for a given node
      Parameters:
        `nodeId` - the ID of node
        `resultHandler` - will be provided with list of sessions
      Returns:
        reference to this, for fluency
      See Also:
        /v1/session/node/:node endpoint

    - #### listNodeSessions

          Future<SessionList> listNodeSessions(String nodeId)

      Like `listNodeSessions(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### listNodeSessionsWithOptions

          ConsulClient listNodeSessionsWithOptions(String nodeId,
                                                   BlockingQueryOptions options,
                                                   Handler<AsyncResult<SessionList>> resultHandler)

      Returns the active sessions for a given node This is blocking query unlike `listNodeSessions(String, Handler)`
      Parameters:
        `nodeId` - the ID of node
        `options` - the blocking options
        `resultHandler` - will be provided with list of sessions
      Returns:
        reference to this, for fluency
      See Also:
        /v1/session/node/:node endpoint

    - #### listNodeSessionsWithOptions

          Future<SessionList> listNodeSessionsWithOptions(String nodeId,
                                                          BlockingQueryOptions options)

      Like `listNodeSessionsWithOptions(String, BlockingQueryOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### destroySession

          ConsulClient destroySession(String id,
                                      Handler<AsyncResult<Void>> resultHandler)

      Destroys the given session
      Parameters:
        `id` - the ID of session
        `resultHandler` - will be called when complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/session/destroy/:uuid endpoint

    - #### destroySession

          Future<Void> destroySession(String id)

      Like `destroySession(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### createPreparedQuery

          ConsulClient createPreparedQuery(PreparedQueryDefinition definition,
                                           Handler<AsyncResult<String>> resultHandler)

      Parameters:
        `definition` - definition of the prepare query
        `resultHandler` - will be provided with id of created prepare query
      Returns:
        reference to this, for fluency
      See Also:
        /v1/query endpoint

    - #### createPreparedQuery

          Future<String> createPreparedQuery(PreparedQueryDefinition definition)

      Like `createPreparedQuery(PreparedQueryDefinition, Handler)` but returns a `Future` of the asynchronous result.

    - #### getPreparedQuery

          ConsulClient getPreparedQuery(String id,
                                        Handler<AsyncResult<PreparedQueryDefinition>> resultHandler)

      Returns an existing prepared query
      Parameters:
        `id` - the id of the query to read
        `resultHandler` - will be provided with definition of the prepare query
      Returns:
        reference to this, for fluency
      See Also:
        /v1/query/:uuid endpoint

    - #### getPreparedQuery

          Future<PreparedQueryDefinition> getPreparedQuery(String id)

      Like `getPreparedQuery(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### getAllPreparedQueries

          ConsulClient getAllPreparedQueries(Handler<AsyncResult<List<PreparedQueryDefinition>>> resultHandler)

      Returns a list of all prepared queries.
      Parameters:
        `resultHandler` - will be provided with list of definitions of the all prepare queries
      Returns:
        reference to this, for fluency
      See Also:
        /v1/query endpoint

    - #### getAllPreparedQueries

          Future<List<PreparedQueryDefinition>> getAllPreparedQueries()

      Like `getAllPreparedQueries(Handler)` but returns a `Future` of the asynchronous result.

    - #### updatePreparedQuery

          ConsulClient updatePreparedQuery(PreparedQueryDefinition definition,
                                           Handler<AsyncResult<Void>> resultHandler)

      Parameters:
        `definition` - definition of the prepare query
        `resultHandler` - will be called when complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/query/:uuid endpoint

    - #### updatePreparedQuery

          Future<Void> updatePreparedQuery(PreparedQueryDefinition definition)

      Like `updatePreparedQuery(PreparedQueryDefinition, Handler)` but returns a `Future` of the asynchronous result.

    - #### deletePreparedQuery

          ConsulClient deletePreparedQuery(String id,
                                           Handler<AsyncResult<Void>> resultHandler)

      Deletes an existing prepared query
      Parameters:
        `id` - the id of the query to delete
        `resultHandler` - will be called when complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/query/:uuid endpoint

    - #### deletePreparedQuery

          Future<Void> deletePreparedQuery(String id)

      Like `deletePreparedQuery(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### executePreparedQuery

          ConsulClient executePreparedQuery(String query,
                                            Handler<AsyncResult<PreparedQueryExecuteResponse>> resultHandler)

      Executes an existing prepared query.
      Parameters:
        `query` - the ID of the query to execute. This can also be the name of an existing prepared query, or a name that matches a prefix name for a prepared query template.
        `resultHandler` - will be provided with response
      Returns:
        reference to this, for fluency
      See Also:
        /v1/query/:uuid/execute endpoint

    - #### executePreparedQuery

          Future<PreparedQueryExecuteResponse> executePreparedQuery(String query)

      Like `executePreparedQuery(String, Handler)` but returns a `Future` of the asynchronous result.

    - #### executePreparedQueryWithOptions

          ConsulClient executePreparedQueryWithOptions(String query,
                                                       PreparedQueryExecuteOptions options,
                                                       Handler<AsyncResult<PreparedQueryExecuteResponse>> resultHandler)

      Executes an existing prepared query.
      Parameters:
        `query` - the ID of the query to execute. This can also be the name of an existing prepared query, or a name that matches a prefix name for a prepared query template.
        `options` - the options used to execute prepared query
        `resultHandler` - will be provided with response
      Returns:
        reference to this, for fluency
      See Also:
        /v1/query/:uuid/execute endpoint

    - #### executePreparedQueryWithOptions

          Future<PreparedQueryExecuteResponse> executePreparedQueryWithOptions(String query,
                                                                               PreparedQueryExecuteOptions options)

      Like `executePreparedQueryWithOptions(String, PreparedQueryExecuteOptions, Handler)` but returns a `Future` of the asynchronous result.

    - #### registerCatalogService

          ConsulClient registerCatalogService(Node nodeOptions,
                                              ServiceOptions serviceOptions,
                                              Handler<AsyncResult<Void>> resultHandler)

      Register node with external service
      Parameters:
        `nodeOptions` - the options of new node
        `serviceOptions` - the options of new service
        `resultHandler` - will be provided with response
      Returns:
        reference to this, for fluency
      See Also:
        /v1/catalog/register endpoint

    - #### deregisterCatalogService

          ConsulClient deregisterCatalogService(String nodeId,
                                                String serviceId,
                                                Handler<AsyncResult<Void>> resultHandler)

      Deregister entities from the node or deregister the node itself.
      Parameters:
        `nodeId` - the ID of node
        `serviceId` - the ID of the service to de-registered; if it is null, the node itself will be de-registered (as well as the entities that belongs to that node)
        `resultHandler` - will be called when complete
      Returns:
        reference to this, for fluency
      See Also:
        /v1/catalog/deregister endpoint

    - #### close

          void close()

      Close the client and release its resources

Copyright © 2024 Eclipse. All rights reserved.